//06
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    Edit1: TEdit;
    Button3: TButton;
    Button4: TButton;
    ListBox1: TListBox;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
  mapa:string;
  pozicex:array [0..100]of integer;
  pozicey:array [0..100]of integer;         //pozice v krocch
  startx,starty:integer;                   //pozice startu
  celkemr:integer;                        //celkov poet dk
  teren:array [0..255,0..255]of integer;   //teren na map
  delka:integer;              //poet sloupc
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var s:textfile;  //natan soubor
str:string;      //natan dek
radek:integer;  //poet dk
pocet:integer; //kolikt znak v dku
barva:tcolor;  //barva polka mapy
x,y:integer;
begin

radek:=0;
if opendialog1.Execute then
if opendialog1.filename='' then else  //jestli je zadn nzev souboru
begin

image1.Canvas.Pen.Color:=clwhite;             //pekreslit plochu na blo
for x:=0 to image1.Width do begin             //
image1.Canvas.MoveTo(0,x);                     //
image1.Canvas.LineTo(image1.Height,x);         //
end;                                           //
image1.Canvas.Pen.Color:=clblack;

 assignfile(s,opendialog1.FileName);
 reset(s);
 celkemr:=0;
 while not eof(s) do begin           //zjist poet dk
 readln(s,str);
 inc(celkemr);
 end;
 closefile(s);                      //zave soubor
 assignfile(s,opendialog1.FileName);
 reset(s);
 while not eof(s) do begin           //dokud nen konec souboru
 readln(s,str);                      //nate dek
 edit1.Text:=str;                    //vlo naten dek do edit1
 delka:=edit1.GetTextLen;            //zjist dlku (poet sloupc)
 for pocet:=0 to edit1.GetTextLen-1 do begin
 teren[pocet,radek]:=0;
 if edit1.Text[pocet+1]='X' then begin  //jestli je pole "zakzan polko"
 teren[pocet,radek]:=1;
 barva:=clblack end else                //nastav barvu na ernou
 if edit1.Text[pocet+1]='S' then begin  //jestli je pole "start"
 startx:=pocet;
 starty:=radek;
 barva:=claqua end else                 //nastav barvu na aqua
 if edit1.Text[pocet+1]='C' then barva:=clred else  //jestli je pole "cl" nastav barvu na ervenou
 if edit1.Text[pocet+1]='.' then barva:=clgreen else //jestli je pole "bezpen a pomal cesta" nastav barvu na zelenou
 if edit1.Text[pocet+1]=':' then barva:=cllime else  //jestli je pole "cesta" nastav barvu na svtle zelenou
 barva:=clwhite;    //jinak barva bl

  image1.Canvas.Pen.Color:=barva;     //nastav barvu podle polka
  x:=0;                                            //nakresli polko s nastavenou barvou
  while x<255 div celkemr+1 do begin
   image1.Canvas.MoveTo(pocet*image1.width div delka,(celkemr-radek-1)*image1.height div celkemr+x);
   image1.Canvas.lineTo(pocet*image1.width div delka+image1.width div delka+1,(celkemr-radek-1)*image1.height div celkemr+x);
   inc(x);
  end;
  image1.Canvas.Pen.Color:=clblack;
                                        //nastav barvu na ernou
 end;
 inc(radek);
 end;
closefile(s);      //zave soubor
end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
close; //zavi okno
end;

procedure TForm1.Button4Click(Sender: TObject);
var s:textfile;     //natan soubor
barva:tcolor;       //barva polka
str:string;         //natan dek
poz,x,z:integer;    //"poz" - kolikt krok
xpoz,ypoz:string;   //rychlost v osch x y
xxx:integer;        //k natn xpoz a ypoz
rychlostx,rychlosty:integer;   //celkov rychlost auto-auta
begin
if opendialog1.Execute then
if opendialog1.filename='' then else
begin
rychlostx:=0;
rychlosty:=0;                //rychlost 0
poz:=1;                      //kolikt krok
pozicex[0]:=startx;          //pozice startu
pozicey[0]:=starty;
 assignfile(s,opendialog1.FileName);
 reset(s);
 while not eof(s) do begin       //natn trasy
 readln(s,str);
 edit1.Text:=str;                     //naten dek do editu
 x:=1;
 xxx:=0;
 xpoz:='';                             //vymazn xpoz a ypoz
 ypoz:='';
 while x<edit1.GetTextLen+1 do begin            //nate se to z editu
  if edit1.Text[x]=',' then xxx:=1 else
  if edit1.Text[x]=' ' then xxx:=2 else
  if xxx=0 then xpoz:=xpoz+edit1.Text[x] else      //rychlost v ose x
  if xxx=2 then ypoz:=ypoz+edit1.Text[x];          //rychlost v ose y

  inc(x);
 end;


   rychlostx:=rychlostx+strtoint(xpoz);            //rychlosti v osch se pidaj k celkov rychlosti
   rychlosty:=rychlosty+strtoint(ypoz);


 pozicex[poz]:=pozicex[poz-1]+rychlostx;           //propot se pozice pomoc pedel pozice a souasn rychlosti
 pozicey[poz]:=pozicey[poz-1]+rychlosty;
  barva:=clyellow;
  image1.Canvas.Pen.Color:=clyellow;     //barva souadnic je lut
    z:=0;
  while z<image1.width div celkemr+1 do begin                 //souednice se zakresl do mapy
   image1.Canvas.MoveTo(pozicex[poz]*image1.width div delka,(pozicey[poz]-1)*image1.height div celkemr+z);
   image1.Canvas.lineTo(pozicex[poz]*image1.width div delka+image1.width div delka+1,(pozicey[poz]-1)*image1.height div celkemr+z);
   inc(z);
  end;
  image1.Canvas.Pen.Color:=clblack;     //barva na ernou


 listbox1.Items.Add(inttostr(pozicex[poz])+' , '+inttostr(celkemr-pozicey[poz])); //zapi souadnici
 if teren[pozicex[poz],pozicey[poz]]=1 then begin
 rychlosty:=0;             //jestli naraz na "zakzan polko" rychlost je 0
 rychlostx:=0; end;
 inc(poz);                 //dal krok
 end;
end;
closefile(s);  //zave soubor
end;

procedure TForm1.FormCreate(Sender: TObject);
var x:integer;
begin
startx:=0;   //pozice startu (jestli se nic jinho nenate)
starty:=0;
end;

end.
